%global _nonzero_exit_pkgcheck_terminate_build 0

%global commit 26cd122a8d10d33091bac50b025df919405a0950
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global chromium_rev   "chromium/3989"

Name:		libpdfium
Version:	0.0.3989
Release:	1%{?dist}
Summary:	PDF generation and rendering library

Group:		Development/Libraries
License:	BSD 3-clause
URL:		https://pdfium.googlesource.com/pdfium/
Source0:	.
# Static Build Argument
Source1:	pdfium-static-args.gn
Source2:	pdfium-shared-args.gn

Patch0:         pdfium-gdal.patch
Patch1:         pdfium-icu.patch
Patch2:         pdfium-test.patch
#Patch3:         pdfium-shared.patch
Patch4:         pdfium-hidden.patch

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	zlib-devel
BuildRequires:  libpng-devel
BuildRequires:  libjpeg-turbo-devel
BuildRequires:  openjpeg2-devel > 2.3.0
BuildRequires:  lcms2-devel
BuildRequires:  devtoolset-8-gcc-c++
BuildRequires:  git

Requires:       zlib
Requires:       libpng
Requires:       libjpeg-turbo
Requires:       openjpeg2
Requires:       lcms2

%description
Used in Chrome for displaying PDFs and print preview. Used in Android for PDF rendering

%package devel
Summary: Libraries and headers for pdfium
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
You should install the libpdfium-devel package if you would like to
compile applications based on pdfium.

%prep

%build

## Don't remove Source Build Tree

## Change GCC 
##scl enable devtoolset-8 bash

export DEPOT_TOOLS_URL="https://chromium.googlesource.com/chromium/tools/depot_tools.git"
export PDFIUM_URL="https://pdfium.googlesource.com/pdfium.git"

mkdir -p %{name}
cd %{name}
export CURDIR=`pwd`
export DEPOT_TOOLS_DIR=$CURDIR/depot_tools
export PATH="$DEPOT_TOOLS_DIR:$PATH"

if [ ! -d "$DEPOT_TOOLS_DIR" ]; then
   git clone "$DEPOT_TOOLS_URL"  depot_tools

# Checkout sources
# From https://pdfium.googlesource.com/pdfium/
   gclient config --unmanaged "$PDFIUM_URL"

# Tested Revision
   gclient sync --revision="$chromium_rev"

# Current Revision
##gclient sync

else
   pushd $DEPOT_TOOLS_DIR
#   git checkout master
#   git pull
   popd
fi


## Static Build
pushd pdfium

if [ ! -f .patch0 ]; then
   patch -p1 < %{PATCH0}
   touch .patch0
fi

if [ ! -f .patch1 ]; then
   patch -p1 < %{PATCH1}
   touch .patch1
fi

if [ ! -f .patch2 ]; then
   patch -p1 < %{PATCH2}
   touch .patch2
fi

if [ ! -f .patch4 ]; then
   patch -p1 < %{PATCH4}
   touch .patch4
fi

rm -rf out/static
mkdir -p out/static
cp -f %{SOURCE1} out/static/args.gn
gn gen out/static

#if [ -f .patch3 ]; then
#   patch -p0 -R < %{PATCH3}
#   rm -f .patch3
#fi

ninja -C out/static pdfium_all

## Shared Build
rm -rf out/shared
mkdir -p out/shared
cp -f %{SOURCE2} out/shared/args.gn
gn gen out/shared

#if [ ! -f .patch3 ]; then
#   patch -p0 < %{PATCH3}
#fi

ninja -C out/shared pdfium_all
popd

%install
mkdir -p %{buildroot}/%{_includedir}/pdfium
mkdir -p %{buildroot}/%{_libdir}

cd %{name}/pdfium

# Header Install
HEADER_SUBDIRS="build fpdfsdk core/fxge core/fxge/agg core/fxge/dib core/fpdfdoc core/fpdfapi/parser core/fpdfapi/page core/fpdfapi/render core/fxcrt third_party/agg23 third_party/base third_party/base/allocator/partition_allocator third_party/base/numerics"

cp -r public %{buildroot}/%{_includedir}/pdfium
for subdir in $HEADER_SUBDIRS; do
    mkdir -p "%{buildroot}/%{_includedir}/pdfium/$subdir"
    cp "$subdir"/*.h  "%{buildroot}/%{_includedir}/pdfium/$subdir"
done

# Static Library Install
install -m 0644 out/static/obj/libpdfium.a %{buildroot}%{_libdir}/libpdfium.a

# Shared Library Install
install -m 0755 out/shared/libpdfium.so %{buildroot}%{_libdir}/
install -m 0755 out/shared/libicuuc_cr.so %{buildroot}%{_libdir}/

%clean
rm -rf %{buildroot}

%check

%if 0
if [ -d libpdfium/pdfium/out/static ]; then
  pushd libpdfium/pdfium/out/static
    ./pdfium_embeddertests
    ./pdfium_unittests
  popd
fi

if [ -d libpdfium/pdfium/out/shared ]; then
  pushd libpdfium/pdfium/out/shared
    ./pdfium_embeddertests
    ./pdfium_unittests
  popd
fi
%endif

%pre

%postun

%files
%defattr(-,root,root,-)
%license libpdfium/pdfium/LICENSE
%doc libpdfium/pdfium/docs
%{_libdir}/libpdfium.so
%{_libdir}/libicuuc_cr.so

%files devel
%defattr(-,root,root,-)
%{_includedir}/pdfium
%{_libdir}/libpdfium.a

%changelog
* Wed Dec 11 2019 N3 <n3syskr@gmail.com> - 0.0.0-1
- initial build

